<?php
/**
*
* @package jQ User Map api3 v.0.0.2
* @version $Id: user_map.php 2356 2012-04-19 22:12:32Z 4seven $
* @copyright (c) 2012 / 4seven
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
define('IN_PHPBB', true);
$phpbb_root_path = (defined('PHPBB_ROOT_PATH')) ? PHPBB_ROOT_PATH : '../';
$phpEx = substr(strrchr(__FILE__, '.'), 1);
include($phpbb_root_path . 'common.' . $phpEx);

$user->session_begin();
$auth->acl($user->data);
$user->setup();

page_header('User Map');

if ($auth->acl_get('u_viewprofile'))
{

//load config file, for later structuring	
include($phpbb_root_path . 'user_weather/user_map_config.' . $phpEx);

	    $template->assign_vars(array(
		'UM_INITIAL_ZOOM' => $map_initial_zoom,
		'UM_CARD_TYPE'    => $user_map_view,
		'UM_CLUSTER_GRID' => $cluster_grid,
		'UM_CLUSTER_ZOOM' => $cluster_max_zoom,
		'U_USER_MAP'	  =>  append_sid("{$phpbb_root_path}user_weather/user_map.$phpEx")
        ));	

		// sql bridge
		$sql = 'SELECT user_id
			    FROM '  . USERS_TABLE . '
				WHERE user_map_latitude != 0';
		// $result = $db->sql_query($sql, 3600);
        $result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{
		$user_id_array[] = $row['user_id'];
		}

		$db->sql_freeresult($result);

    $row_visibles = array(0);
	$row_hiddens  = array(0);
	
// online track thang		
if ($config['load_onlinetrack'] && (isset($user_id_array) && sizeof($user_id_array)))	
{
	$sql = 'SELECT session_user_id, session_viewonline, MAX(session_time) as online_time, MIN(session_viewonline) AS viewonline
		    FROM ' . SESSIONS_TABLE . '
		    WHERE ' . $db->sql_in_set('session_user_id', $user_id_array) . '
		    GROUP BY session_user_id';
	$result = $db->sql_query($sql);

	$update_time = $config['load_online_time'] * 60;

	while ($row = $db->sql_fetchrow($result))
	{		
		$row_visible = (time() - $update_time < $row['online_time'] && ($row['session_viewonline'] != 0) && (($row['viewonline']) || $auth->acl_get('u_viewprofile'))) ? $row['session_user_id'] : false;	
		$row_hidden = (time() - $update_time < $row['online_time'] && ($row['session_viewonline'] == 0) && (($row['viewonline']) || $auth->acl_get('u_viewprofile'))) ? $row['session_user_id'] : false;

		$row_visibles[] = $row_visible;
		$row_hiddens[]  = $row_hidden;
	}

	$db->sql_freeresult($result);

			// that must be
			$sql = 'UPDATE ' . USERS_TABLE . '
			        SET user_jq_online =' . (int) 0 . '
			        WHERE ' . $db->sql_in_set('user_id', array_merge($row_visibles, $row_hiddens), true); 
	        $db->sql_query($sql);

			$sql = 'UPDATE ' . USERS_TABLE . '
					SET user_jq_online =' . (int) 1 . '
					WHERE ' . $db->sql_in_set('user_id', $row_visibles);
			$db->sql_query($sql);

			$sql = 'UPDATE ' . USERS_TABLE . '
					SET user_jq_online =' . (int) 2 . '
					WHERE ' . $db->sql_in_set('user_id', $row_hiddens);
			$db->sql_query($sql);

}

	if (!function_exists('get_user_avatar'))
	{
	include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
	}

		$sql = 'SELECT user_id, username, user_colour, user_avatar, user_avatar_type, user_avatar_width, user_avatar_height, user_map_latitude, user_map_longitude, user_jq_online, user_map_location, user_map_location_desc
			    FROM '  . USERS_TABLE . '
				WHERE user_map_latitude != 0
				ORDER BY username_clean';
        $result = $db->sql_query($sql);

		// no cached result		
		while ($row = $db->sql_fetchrow($result))
		{

		switch ($row['user_jq_online']) 
		{
  	      case 0:
  	      $online_colour = $off_colour;
  	      break;
  	      case 1:
  	      $online_colour = $onl_colour;
  	      break;
  	      case (2 && ($row['user_id'] == $user->data['user_id'])) || (2 && ($auth->acl_get('a_') && !empty($user->data['is_registered']))):
  	      $online_colour = $hid_colour;
  	      break;
  	      default:
  	      $online_colour = $off_colour;
  	      // no break		
		}

		$row_usernames = get_username_string('no_profile', $row['user_id'], $row['username'], $row['user_colour']);
		$row_username  = utf8_encode(urlencode($row['username']));

		$template->assign_block_vars('user_map', array(

			'UM_LATITUDE'      => $row['user_map_latitude'],
			'UM_LONGITUDE'     => $row['user_map_longitude'],
			'UM_USER_ID'       => $row['user_id'],
			'UM_ON_COLOUR'     => $online_colour,
		    'UM_USERNAMES'     => $row_usernames,
		    'UM_USERNAME'      => $row_username,
			'UM_USER_PROFILE'  => str_replace('&amp;', '&', append_sid("{$phpbb_root_path}memberlist.$phpEx", 'mode=viewprofile&u=' . $row['user_id'])),
			'UM_USERAVATAR'    => (!empty($row['user_avatar'])) ? get_user_avatar($row['user_avatar'], $row['user_avatar_type'], $row['user_avatar_width'], $row['user_avatar_height']) : '<img src="'.$phpbb_root_path.'images/no_avatar.png" alt="" />',
            'UM_LOCATION'      => ucwords(str_replace('_', ' ', $row['user_map_location'])),
            'UM_LOCATION_DESC' => ($row['user_map_location_desc'] !== 0) ? $row['user_map_location_desc'] : false

			));	

		$row_exists[] = $row['user_id'];

		}
		
		$db->sql_freeresult($result);

		if($overlay_true == true){

	    $weather_true	= request_var('weather', 0);
	    $clouds_true	= request_var('clouds', 0);
	
		$template->assign_vars(array(

		'UM_ACTIVE'   => isset($row_exists) ? true : false,
		'S_OVER_TRUE' => true,
		'CEL_FAH'     => ($celsius == true) ? 'CELSIUS' : 'FAHRENHEIT',
		'S_WEATHER'   => ($weather_true == 1) ? 1 : 0,
		'S_CLOUDS'    => ($clouds_true == 1) ? 1 : 0

		));}
		
		else{
		
		$template->assign_var('UM_ACTIVE', isset($row_exists) ? true : false);}

}		

$template->set_filenames(array(
'body' => 'user_map.html'));

page_footer();

?>